Subject: Re: [PATCH v2 0/3] devlink region trigger support

From: Jakub Kicinski <[email-masked]>
Date: Sun, 12 Jan 2020 12:45:21 -0800

On Sat, 11 Jan 2020 09:51:00 +0800, Yunsheng Lin wrote:
> > regions can essentially be used to dump arbitrary addressable content. I
> > think all of the above are great examples.
> > 
> > I have a series of patches to update and convert the devlink
> > documentation, and I do provide some further detail in the new
> > devlink-region.rst file.
> > 
> > Perhaps you could review that and provide suggestions on what would make
> > sense to add there?  
> 
> For the case of region for mlx4, I am not sure it worths the effort to
> document it, because Jiri has mention that there was plan to convert mlx4 to
> use "devlink health" api for the above case.
> 
> Also, there is dpipe, health and region api:
> For health and region, they seems similar to me, and the non-essential
> difference is:
> 1. health can be used used to dump content of tlv style, and can be triggered
>    by driver automatically or by user manually.
> 
> 2. region can be used to dump binary content and can be triggered by driver
>    automatically only.
> 
> It would be good to merged the above to the same api(perhaps merge the binary
> content dumping of region api to health api), then we can resue the same dump
> ops for both driver and user triggering case.

I think there is a fundamental difference between health API and
regions in the fact that health reporters allow for returning
structured data from different sources which are associated with 
an event/error condition. That includes information read from the
hardware or driver/software state. Region API (as Jake said) is good
for dumping arbitrary addressable content, e.g. registers. I don't see
much use for merging the two right now, FWIW...